#include <X11/extensions/XTest.h>
#include <X11/extensions/XInput.h>
//#include <X11/extensions/XInput2.h>

#define DEFAULT_DELAY 12

/*"xdo" could maybe contain "current mouse" and have switch commands*/
/*using XInput v1 because that's what XTest uses*/
static int _is_success(const char *funcname, int code, const xdo_t *xdo) {
  /* Nonzero is failure. */
  if (code != 0 && !xdo->quiet)
    fprintf(stderr, "%s failed (code=%d)\n", funcname, code);
  return code;
}
static int _xdo_devbutton(const xdo_t *xdo, int devid, Window window, int button, int is_press, int *pos) {
  int ret = 0;

  if (window == CURRENTWINDOW) {
    XDevice *dev=XOpenDevice(xdo->xdpy,(XID)devid);
    if(!pos){int p[2];pos=p;/*query dev.*/;}
    ret = XTestFakeDeviceButtonEvent(xdo->xdpy, dev, button, is_press, pos, 2, CurrentTime);
    XFlush(xdo->xdpy);
    XCloseDevice(xdo->xdpy,dev);
    return _is_success("XTestFakeDeviceButtonEvent(down)", ret == 0, xdo);
  }

  return ret;
}
inline int xdo_devup(const xdo_t *xdo, int devid, Window window, int button, int *pos) {
  return _xdo_devbutton(xdo, devid, window, button, False, pos);
}
inline int xdo_devdown(const xdo_t *xdo, int devid, Window window, int button, int *pos) {
  return _xdo_devbutton(xdo, devid, window, button, True, pos);
}
int xdo_devclick(const xdo_t *xdo, int devid, Window window, int button, int *pos) {
  int ret = 0;
  ret = xdo_devdown(xdo, devid, window, button, pos);
  if (ret != XDO_SUCCESS) {
    fprintf(stderr, "xdo_devdown failed, aborting click.\n");
    return ret;
  }
  usleep(DEFAULT_DELAY);
  ret = xdo_devup(xdo, devid, window, button, pos);
  return ret;
}