#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/XKBlib.h>
#include <stdio.h>
#include <malloc.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <libgen.h> /*for basename*/
#include "xdotool/xdo.h"
#include "xdo2.c"

typedef long long llong/*typedef int64_t llong*/;
#define fromstr(a) /*(llong)int*/strtoll(a,NULL,0/*base*/)
#define fromstr16(a) /*(llong)int*/strtoll(a,NULL,16/*base*/)
char *tostr16(llong numb)
{	static char *str ;if(str) free(str);
	int len=snprintf(NULL,0,"%llx",numb);str=malloc(len+1);
	snprintf(str,len+1,"%llx",numb);
	return str;}
#define frep(s,expr1) ({char *macvar=s;s=expr1;free(macvar);s;})
#define lstrpe_c(s,c) s=lstrp_c(s,&len_##s,c)
char *lstrp_c(char *str,int *len_str_p,char c)
{	int len,len1;
	len=(!str)?0:*len_str_p;len1=len;
	len+=1;
	str=realloc(str,len+1);
	char *dest=str+len1;
	*dest=c ;dest+=1 ;*dest='\0';
	*len_str_p=len;return str;
}char *basename_safe(char *path)
{	int len_path=strlen(path);
	if(len_path&&path[len_path-1]=='/')lstrpe_c(path,'.');
	frep(path,strdup(basename(path)));return path;
}char *readall(int fd,ssize_t *s_return)/*free result*/
{	char *out=0 ;ssize_t s;ssize_t len=0;
	while(1)
{		out=realloc(out,len+512);
		s=read(fd,out+len,512);if(s<0)break;
		else if(s==0)break;
		else len+=s;
}	if(s_return)*s_return=len;
	out=realloc(out,len+1);
	out[len]='\0';return out;
}void writeall(int fd,char *buf,size_t s)
{	while(s>=512)
{		write(fd,buf,512);s-=512;buf+=512;
}	if(s)write(fd,buf,s)
;
}XWindowAttributes attr;
XSetWindowAttributes attri;
Display *dpy,*dpy_o;GC gc1;
Window root;int rootdepth
;
int bogus_handler(Display *dpy, XErrorEvent *err)
{	return 0;
}char x_wexists(Window w)
{	void *handler1=XSetErrorHandler(&bogus_handler);
	char ret=0;
	if(w)
{		if(XGetWindowAttributes(dpy,w,&attr))ret=1;
}	XSetErrorHandler(handler1);
	return ret;
}Window window_from_file(char *fn,int wx,int wy,int ww,int wh)
{	Window w1;char succ=0;
	int fd;fd=open(fn,O_RDONLY);if(fd>=0)
{		char *tmp=readall(fd,NULL);w1=fromstr16(tmp);free(tmp);
		if(x_wexists(w1))succ=1 ;close(fd);
}	if(!succ)
{		//XSetCloseDownMode(dpy,RetainPermanent);
		w1=XCreateSimpleWindow(dpy,root,wx,wy,ww,wh,0,0,-1);
		char *a=basename_safe(strdup(fn));XStoreName(dpy,w1,a);free(a);
		a=tostr16(w1);fd=open(fn,O_WRONLY|O_CREAT|O_TRUNC);if(fd>=0)
{			writeall(fd,a,strlen(a));close(fd);
}		XMapWindow(dpy,w1);
		XSync(dpy,False);
		/*actually use xclose -nf*/;
}	return w1
;
}char monitor_set(char monitor_state/*0 off 1 on*/)
{	if(!monitor_state)system("xrandr --output LVDS --off");
	else system("xrandr --output LVDS --auto;test -f ./xrandrindex&&( xrandr -s \"$(cat ./xrandrindex|cut -f1 -d\\@)\";exit 0;)||cat ./xrandrindex");
	return monitor_state
;
}static int handler(Display *dpy, XErrorEvent *err)
{	printf("xerr error=%d request=%d.%d id=0x%llx\n",err->error_code,err->request_code,err->minor_code,(long long)err->resourceid);return 0;
}char ending=0;
#include <signal.h>
struct sigaction sa_info;
void sigaction_handler(int sig)
{	if(sig==SIGTERM)ending=1;
}int main(int argc,char **argv)
{	sa_info.sa_handler=&sigaction_handler;
	sigaction(SIGTERM,&sa_info,NULL)
;
	XEvent ev
;
	char *dpy_s;
	dpy= XOpenDisplay(NULL);if(dpy)dpy_s=getenv("DISPLAY");
	if(!dpy)
{		dpy_s=":0";dpy= XOpenDisplay(dpy_s);
}	if(!dpy)goto lab_msg1;
	if(0)XSetCloseDownMode(dpy,RetainTemporary);
	XSetErrorHandler(&handler)
;
	if(argc<2)goto lab_msg1;char *dpy_o_s;
	dpy_o_s=argv[1];if(!strcmp(dpy_s,dpy_o_s))goto lab_msg1;
	dpy_o= XOpenDisplay(dpy_o_s);
	if(!dpy_o)goto lab_msg1;if(0)
{		lab_msg1:;dprintf(2,"couldn't open display\n");return 1
;
}	root = DefaultRootWindow(dpy);
	/*man xevent ;man XCreateWindowEvent ;page 185,199*/;
	XGetWindowAttributes(dpy,root,&attr);rootdepth=attr.depth;
	int root_r[6]/*bw,depth*/;Window root_return;
	XGetGeometry(dpy,root,&root_return,root_r+0,root_r+1,root_r+2,root_r+3,root_r+4,root_r+5);
	Window root_o = DefaultRootWindow(dpy_o);
	int root_o_r[6]/*bw,depth*/;//Window root_return;
	XGetGeometry(dpy_o,root_o,&root_return,root_o_r+0,root_o_r+1,root_o_r+2,root_o_r+3,root_o_r+4,root_o_r+5)
;
	xdo_t *xtool=xdo_new_with_opened_display(dpy_o,dpy_o_s,0);
	if(1)/*XDisplayName doesn't work (it still returns diff. strings for what was the same display)*/
{		xdo_t *xtool_i=xdo_new_with_opened_display(dpy,dpy_s,0);
		int x1,y1,screen;int x2,y2,screen2 ;char same=0;
		xdo_mouselocation(xtool_i,&x1,&y1,&screen);
		int x=10,y=10;while(x<=60)
{			xdo_mousemove(xtool_i,x,y,screen);
			xdo_mouselocation(xtool,&x2,&y2,&screen2);
			//dprintf(2,"%d %d\n",x2,y2);//xdotool bug sets y=y-1;
			if(abs(x-x2)<=1&&abs(y-y2)<=1)same+=1 ;x+=10;
}		xdo_mousemove(xtool_i,x1,y1,screen) ;xdo_free(xtool_i) ;if(same>=3)
{			dprintf(2,"same display detected %d/6\n",(int)same);return 1
;
}}	int ctrl=XkbKeysymToModifiers(dpy,XK_Control_L);
	int meta=XkbKeysymToModifiers(dpy,XK_Alt_L);
	int shift=XkbKeysymToModifiers(dpy,XK_Shift_L);
	int mod=XkbKeysymToModifiers(dpy,XK_Super_L)
;
	//Window w1=window_from_file("/tmp/xforw_w1",0,0,400,400);
	int mouse2=-1;if(1)
{		int n,n2;XDeviceInfo *devl=XListInputDevices(dpy_o,&n2);
		n=0;while(n<n2)
{			if(!strcmp(devl[n].name,"Mouse 2"))mouse2=devl[n].id;
			n+=1;
}		if(mouse2<0)
{			dprintf(2,"warning: couldn't find 2nd mouse\n");
			n=0;while(n<n2)
{				dprintf(2,"name [%s]\n",devl[n].name) ;n+=1;
}}		XFreeDeviceList(devl)
;
}	if(XGrabPointer(dpy,root,False,/*int event_mask*/ButtonPressMask|ButtonReleaseMask|PointerMotionMask,/*pointer*/GrabModeAsync,GrabModeAsync,None,None,CurrentTime)!=GrabSuccess)goto lab_msg2;
	if(XGrabKeyboard(dpy,root,False,/*int event_mask=KeyPressMask|KeyReleaseMask,*//*pointer*/GrabModeAsync,GrabModeAsync,CurrentTime)!=GrabSuccess)goto lab_msg2;if(0)
{		lab_msg2:;dprintf(2,"couldn't grab input\n");return 1;
}	/*GrabModeSync grabbed it, but didn't get events;
	also, didn't grab it when window was just created, even after calling XSync*/
;
	char monitor_state=1;if(1)
{		char *a=getenv("monitor_state");if(a)
{			if(a[0]&&a[0]!='0')monitor_state=1;
}		if(!monitor_state)monitor_set(monitor_state)/*assume monitor is on on startup*/;
}	system("xset -dpms");//#xset -q|less
;
	int mx,my;char mb,mset;
	int out_x=0,out_y=0 ;char motion_first=1;int prev_motion_mx,prev_motion_my;
	while(1)
{		if(XCheckMaskEvent(dpy,~NoEventMask,&ev)==False)
{			if(ending)
{				system("xset +dpms");
				XUngrabPointer(dpy,CurrentTime);
				XUngrabKeyboard(dpy,CurrentTime);
				XCloseDisplay(dpy)/*maybe this would work in signal handler if threads enabled*/;exit(0);
}			usleep(2000/*2 ms*/);continue;//XNextEvent(dpy, &ev);
}		//dprintf(2,"ev \n");
		if(ev.type==ButtonPress)
{			if(1||ev.xany.window==root)
{				//mset=1;mx=ev.xbutton.x;my=ev.xbutton.y;mb=ev.xbutton.button;
				//dprintf(2,"press %d %d %d\n",mx,my,(int)mb);
				xdo_mousedown(xtool,CURRENTWINDOW,ev.xbutton.button);
}}		else if(ev.type==ButtonRelease)
{			xdo_mouseup(xtool,CURRENTWINDOW,ev.xbutton.button);
}		else if(ev.type==MotionNotify)
{			mset=1;mx=ev.xmotion.x;my=ev.xmotion.y;mb=5;
			if(motion_first)motion_first=0;else
{				int tmp;const bw=2;char flag=0;
				tmp=mx-prev_motion_mx;if(tmp<0)tmp=-tmp;if(tmp<bw);else flag=1;
				tmp=my-prev_motion_my;if(tmp<0)tmp=-tmp;if(tmp<bw);else flag=1;
				if(flag);else goto motion_skip;
}			//dprintf(2,"move %d %d\n",mx,my);
			const bw=200;if(1)
{				int x=mx,y=my;char flag[]={1,1};
				if(x<root_r[0]+bw)
{					x+=root_r[2]-2*bw;out_x-=root_r[2]-2*bw;if(out_x<0)out_x=(out_x+root_o_r[2])%root_o_r[2];
}				else if(root_r[0]+root_r[2]-bw<=x)
{					x-=root_r[2]-2*bw;out_x+=root_r[2]-2*bw;if(root_o_r[2]<out_x)out_x=out_x%root_o_r[2];
}				else flag[0]=0;
				if(y<root_r[1]+bw)
{					y+=root_r[3]-2*bw;out_y-=root_r[3]-2*bw;if(out_y<0)out_y=(out_y+root_o_r[3])%root_o_r[3];
}				else if(root_r[1]+root_r[3]-bw<=y)
{					y-=root_r[3]-2*bw;out_y+=root_r[3]-2*bw;if(root_o_r[3]<out_y)out_y=out_y%root_o_r[3];
}				else flag[1]=0;
				if(flag[0]||flag[1])
{					XWarpPointer(dpy,None,root,0,0,0,0,x,y);mx=x;my=y;
}}			xdo_mousemove(xtool,root_o_r[0]+(out_x+mx-bw-root_r[0])%root_o_r[2],root_o_r[1]+(out_y+my-bw-root_r[1])%root_o_r[3],0);
			prev_motion_mx=mx;prev_motion_my=my;motion_skip:;
}		else if(ev.type==KeyPress/*||ev.type==KeyRelease*/){
			#define xkc(s) XKeysymToKeycode(dpy,s)
			if(ev.type==KeyPress&&(ev.xkey.state&ctrl)&&(ev.xkey.state&mod)&&ev.xkey.keycode==xkc(XK_Z))
{				monitor_state=monitor_set(!monitor_state);
				/*ending=1;*/goto key_skip;}
			#include "keyb_map.c"

			struct tr1
{				KeySym from,to;KeyCode kc_from,kc_to;
}			;//;
			#define _(a,b) {.from=XK_##a,.to=XK_##b}
			static struct tr1 tr1[]={_(Control_R,Control_L),_(Alt_R,Alt_L),_(Shift_R,Shift_L),_(Super_R,Super_L)};
			#undef _
			int len_tr1=sizeof(tr1)/sizeof(tr1[0]);
			static char never2=1;if(never2)
{				never2=0;
				int n=0;while(n<len_tr1)
{					tr1[n].kc_from=xkc(tr1[n].from);tr1[n].kc_to=xkc(tr1[n].to) ;n+=1;
}}			if(1)
{				int n=0;while(n<len_tr1)
{					if(ev.xkey.keycode==tr1[n].kc_from)ev.xkey.keycode=tr1[n].kc_to ;n+=1
;
}}			const int out_x=0,out_y=root_o_r[3]-bw*6;
			int x=0,y=0;
			int n=0;while(1)
{				if(map[n].ex_w==-1)
{					x=0;y+=bw;
}				else if(map[n].ex_w==-2)break;else
{					if(ev.xkey.keycode==map[n].keycode)break;
					x+=(2+map[n].ex_w)*bw/2;
}				n+=1;
}			if(map[n].ex_w==-2||map[n].sym==XK_VoidSymbol);
			else if(map[n].sym==XK_F2)ending=1;else
{				/*maybe a func. like xdo_window_select_with_click could also absorb mousemove and appear to keep the pointer stationary*/;
				if(mouse2>=0)
{					int pos[]={root_o_r[0]+out_x+x+bw/2,root_o_r[1]+out_y+y+bw/2};
					//dprintf(2,"press2 %d %d\n",pos[0],pos[1]);
					pos[0]*=2;pos[1]*=2;
					xdo_devclick(xtool,mouse2,CURRENTWINDOW,1,pos);
}}			key_skip:;
			#undef xkc
}}}//# cpp.py xforw keyb_map;gcc xforw.c -o xforw -lX11 -l:libxdo.so.2 -lXtst -lXi -Wall|& gccw|less;
